Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 423125 - app-arch/lha fails to build with automake 1.12
Summary: app-arch/lha fails to build with automake 1.12
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: New packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Jared B.
URL: https://tinderboxlogs.s3.amazonaws.co...
Whiteboard:
Keywords:
Depends on:
Blocks: automake-1.12
  Show dependency tree
 
Reported: 2012-06-23 11:47 UTC by Diego Elio Pettenò (RETIRED)
Modified: 2012-06-24 13:30 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Diego Elio Pettenò (RETIRED) gentoo-dev 2012-06-23 11:47:09 UTC
Portage 2.2.0_alpha110 (default/linux/amd64/10.0, gcc-4.7.1, glibc-2.15-r2, 3.4.2-hardened x86_64)
=================================================================
System uname: Linux-3.4.2-hardened-x86_64-AMD_Opteron-TM-_Processor_6272-with-gentoo-2.1
Timestamp of tree: Sat, 16 Jun 2012 07:30:01 +0000
app-shells/bash:          4.2_p29
dev-java/java-config:     2.1.11-r3
dev-lang/python:          2.7.3-r2, 3.2.3-r1
dev-util/cmake:           2.8.8-r3
dev-util/pkgconfig:       0.26
sys-apps/baselayout:      2.1-r1
sys-apps/openrc:          0.10.3
sys-apps/sandbox:         2.5
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.9.6-r3, 1.11.5, 1.12.1
sys-devel/binutils:       2.22-r1
sys-devel/gcc:            4.5.3-r2, 4.7.1
sys-devel/gcc-config:     1.7.3
sys-devel/libtool:        2.4.2
sys-devel/make:           3.82-r3
sys-kernel/linux-headers: 3.4 (virtual/os-headers)
sys-libs/glibc:           2.15-r2
Repositories: gentoo
Installed sets: 
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -ggdb -march=native -ftracer"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -pipe -ggdb -march=native -ftracer"
DISTDIR="/var/cache/portage/distfiles"
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles news parallel-fetch parse-eapi-ebuild-head protect-owned sandbox sfperms strict test test-fail-continue unknown-features-warn unmerge-orphans userfetch userpriv usersandbox"
FFLAGS=""
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="en_US.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j24"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/tmp"
PORTDIR="/var/cache/portage/tree"
PORTDIR_OVERLAY=""
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="3dnow 3dnowex acl amd64 berkdb bzip2 cli cracklib crypt cups cxx dri ffmpeg fortran gdbm gpm iconv ipv6 mmx modules mudflap multilib ncurses nls nptl openmp pam pcre pppd qt3support readline session sse sse2 sse3 sse4 ssl ssse3 tcpd unicode vhosts xorg zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" PHP_TARGETS="php5-3" PYTHON_TARGETS="python3_2 python2_7" RUBY_TARGETS="ruby18 jruby ruby19 ree18" USERLAND="GNU" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, LINGUAS, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, USE_PYTHON
Comment 1 Rafał Mużyło 2012-06-23 13:19:15 UTC
Standard solution would apply: remove the macro, pass -DPROTOTYPES to cppflags...

But it seems that it's used only in src/prototypes.h, so you could simply patch that file.
Comment 2 Michael Weber (RETIRED) gentoo-dev 2012-06-23 15:17:58 UTC
@flameeyes

* Include in your bugreport the contents of:
*
* /tmp/portage/app-arch/lha-114i-r7/temp/aclocal.out
Comment 3 Rafał Mużyło 2012-06-23 16:57:04 UTC
(In reply to comment #2)
> @flameeyes
> 
> * Include in your bugreport the contents of:
> *
> * /tmp/portage/app-arch/lha-114i-r7/temp/aclocal.out

It's already included - the files are cat-ed into a single one.
Comment 4 Diego Elio Pettenò (RETIRED) gentoo-dev 2012-06-24 06:07:57 UTC
Uh, Rafal, AM_C_PROTOTYPES is not even defining PROTOTYPES, AC_C_PROTOTYPES is (which is probably what one wants to call at that point, it's not declared yet afaict).
Comment 5 Diego Elio Pettenò (RETIRED) gentoo-dev 2012-06-24 06:08:05 UTC
*it's not declared deprecated yet.
Comment 6 Rafał Mużyło 2012-06-24 08:02:20 UTC
(In reply to comment #5)
> *it's not declared deprecated yet.

sort of wrong - from automake 1.11 (/usr/share/automake-1.11/protos.m4)

AC_DEFUN([AM_C_PROTOTYPES],
[AC_REQUIRE([AC_C_PROTOTYPES])
AC_DIAGNOSE([obsolete],
            [$0: automatic de-ANSI-fication support is deprecated])
if test "$ac_cv_prog_cc_stdc" != no; then
  U= ANSI2KNR=
else
  U=_ ANSI2KNR=./ansi2knr
fi
# Ensure some checks needed by ansi2knr itself.
AC_REQUIRE([AC_HEADER_STDC])
AC_CHECK_HEADERS([string.h])
AC_SUBST([U])dnl
AC_SUBST([ANSI2KNR])dnl
_AM_SUBST_NOTMAKE([ANSI2KNR])dnl
])

in 1.12 it's just:
AC_DEFUN([AM_C_PROTOTYPES],
         [AC_FATAL([automatic de-ANSI-fication support has been removed])])

obviously it does define PROTOTYPES, due to AC_REQUIRE.

It's not a particular macro, that's deprecated, it's whole de-ANSI-fication.
Comment 7 Diego Elio Pettenò (RETIRED) gentoo-dev 2012-06-24 08:33:34 UTC
Repeating myself (with the correction applied):

Uh, Rafal, AM_C_PROTOTYPES is not even defining PROTOTYPES, AC_C_PROTOTYPES is (which is probably what one wants to call at that point, it's not declared deprecated yet afaict).

Read me again, carefully.

AM_C_PROTOTYPES (AM!) is deprecated in 1.11 and gone in 1.12.
AC_C_PROTOTYPES (AC!) is not deprecated, it's provided by autoconf (not automake) and defines PROTOTYPES.

See http://www.flameeyes.eu/autotools-mythbuster/forwardporting/automake.html as well.

Please don't just add -DPROTOTYPES magically, as we'll lose track of it altogether otherwise.
Comment 8 Rafał Mużyło 2012-06-24 08:53:51 UTC
While *technically* not deprecated, 'info autoconf' on AC_C_PROTOTYPES:
-- Macro: AC_C_PROTOTYPES:
...
     This macro is obsolescent, as current C compilers support
     prototypes.  New programs need not use this macro.

so while I'm not autoconf upstream, so can't say for sure, most likely the only reason this macro wasn't already deprecated was... automake.
Comment 9 Diego Elio Pettenò (RETIRED) gentoo-dev 2012-06-24 08:57:47 UTC
Obsolete is different from deprecated — unfortunately.

My only point though is I'd prefer replacing the AM macro with the AC macro instead of using -DPROTOTYPES — if you want to get rid of the macro altogether, then simply remove the _need_ for -DPROTOTYPE at once (who the hell still uses ANSI C?!).
Comment 10 Rafał Mużyło 2012-06-24 09:02:15 UTC
As for your page - thanks for doing the work, but in this particular case you're digging too deep into implementation.
The only *public* effect of AM_C_PROTOTYPES (besides those from AC_C_PROTOTYPES) was setting ANSI2KNR vars/rules. The other two were private and only for benefit of ansi2knr.c.
(btw, you've made a slight typo in the new block)
Comment 11 Diego Elio Pettenò (RETIRED) gentoo-dev 2012-06-24 09:06:19 UTC
I know that was the intention of automake.

On the other hand I know that half the time things are done as side effects, somebody _is_ relying on said side effects.

I've seen more than once a macro being slimmed down causing miscompilation because one test it was doing was relied upon, but never made explicit.
Comment 12 Rafał Mużyło 2012-06-24 09:08:59 UTC
...but now, that I've read that paragraph again, I see that you've got the order wrong - it's ANSI C, that was the *new* standard, K&R was the initial C implementation and ansi2knr from the very start was provided for backward compatibility.
Comment 13 Diego Elio Pettenò (RETIRED) gentoo-dev 2012-06-24 09:14:18 UTC
Sigh that one I always get wrong (used to think about _ISO_ C as the current one). But we're swamping Jared with information he doesn't care about, can we just stick with:

 - don't just define -DPROTOTYPES;
 - if you're in touch with lha upstream, make them drop the whole reliance on PROTOTYPES define;
 - make sure that the package is not relying on other macros called by AM_C_PROTOTYPES (namely the AC_HEADER_STDC and AC_CHECK_HEADERS([string.h]);
 - replace AM_C_PROTOTYPES with AC_C_PROTOTYPES.
Comment 14 Rafał Mużyło 2012-06-24 09:41:34 UTC
:lol: "if you're in touch with lha upstream"...
the one, that hasn't released a thing since 2006/10/16 (even if there was a bit work done in the repo http://sourceforge.jp/projects/lha/scm/git/lha/) ? 
Also, I neither speak nor read Japanese (can barely work with rikai.com guesses).
Besides, AFAICT, the upstream simply ran autoscan at some point back in 2001.
Comment 15 Diego Elio Pettenò (RETIRED) gentoo-dev 2012-06-24 09:48:11 UTC
I really don't care to know the details of projects I don't maintain. Whether there is an upstream or not it's of very little interest to me. If needed fork it, or whatever.

Just do it properly and not with a partial hack as you suggested to begin with.
Comment 16 Samuli Suominen gentoo-dev 2012-06-24 09:57:56 UTC
Diego, I suppose there are no direct replacement for AM_C_PROTOTYPES, right? 

People have been telling me to just drop it and append -DPROTOTYPES to CPPFLAGS for #ifdef's.

Fixed in tree now. Let me know if you know better fix for this.
Comment 17 Rafał Mużyło 2012-06-24 10:03:48 UTC
...anyway, my initial comment was aimed at this particular package.
AC_HEADER_STDC is already called in configure.ac (and that macro already checks for string.h), so AFAICT, in this particular case, appending -DPROTOTYPES should be a safe solution.
Comment 18 Rafał Mużyło 2012-06-24 10:08:07 UTC
(In reply to comment #16)
> I suppose there are no direct replacement for AM_C_PROTOTYPES, right? 
> 
There is no direct replacement, cause unless the upstream was relying on side effects of that macro, its only effect outside automake was "-DPROTOTYPES -D__PROTOTYPES", with the second definition used rarely ever.
Comment 19 Diego Elio Pettenò (RETIRED) gentoo-dev 2012-06-24 10:08:19 UTC
Then just say you checked it already next time — it didn't appear the case (you said "standard solution", but the only way you have a standard solution is using an idempotent replacement).
Comment 20 Samuli Suominen gentoo-dev 2012-06-24 10:12:50 UTC
uh hu, guys, I completely missed this bug already had a discussion about it (expected a boilerplate Comment #0 and that's it)

and of course I've checked all the C files for *PROTOTYPE*...

OK then :P
Comment 21 Rafał Mużyło 2012-06-24 10:58:00 UTC
Well, I said "standard solution" cause it seems to me that *most* of AC_C_PROTOTYPES users didn't really know why did they use it in the first place, so *usually* "-DPROTOTYPES" does suffice.
Comment 22 Diego Elio Pettenò (RETIRED) gentoo-dev 2012-06-24 11:39:03 UTC
WILL YOU STOP REOPENING THE BUG? Samuli fixed it.
Comment 23 Rafał Mużyło 2012-06-24 13:30:22 UTC
(In reply to comment #22)
> WILL YOU STOP REOPENING THE BUG? Samuli fixed it.

sorry, accident, most of the times, that bugzilla warning is a false positive, so I tend to ignore it